## intel-ipsec-mb 2.0.1

=== CMakeLists.txt ===
# cmake-format: off
# Copyright (c) 2022-2024, Intel Corporation
# Copyright 2000-2023 Kitware, Inc. and Contributors
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# cmake-format: on

cmake_minimum_required(VERSION 3.16)
cmake_policy(VERSION 3.16)

include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/utils.cmake")

# get version from public header file
set(IMB_HDR "${CMAKE_CURRENT_SOURCE_DIR}/lib/intel-ipsec-mb.h")
imb_get_version(${IMB_HDR})
message(STATUS "Project Version: ${IPSEC_MB_VERSION_FULL}")

# set default project values
imb_set_proj_defaults()

project(
  intel-ipsec-mb
  VERSION ${IPSEC_MB_VERSION}
  DESCRIPTION "Intel(R) IPsec Multi-Buffer library"
  LANGUAGES C ASM
  HOMEPAGE_URL https://github.com/intel/intel-ipsec-mb/)

# add testing support
include(CTest)

# set binary output directory if specified
imb_set_binary_dir()

# detect OS
imb_detect_os()

# do compiler checks
imb_compiler_check()

# ##############################################################################
# configure pre gen custom targets
# ##############################################################################

# add custom target to uninstall library
imb_add_target_uninstall(
  "${CMAKE_CURRENT_SOURCE_DIR}/lib/cmake/uninstall.cmake.in")

# style check target
imb_add_target_style_checks()

# TAGS target
imb_add_target_tags()

# spellcheck target
imb_add_target_spellcheck()

# cppcheck and bughunt targets
imb_add_target_cppcheck_bughunt()

# doxy target to generate documentation
imb_add_target_doxy()

# ##############################################################################
# configure main project targets
# ##############################################################################

# build library
add_subdirectory(lib)

if(NOT BUILD_LIBRARY_ONLY)
  # build perf application
  add_subdirectory(perf)

  # build test applications
  add_subdirectory(test)

  # build example applications
  add_subdirectory(examples)
endif()

# ##############################################################################
# configure post gen custom targets
# ##############################################################################

# add custom target to print help information
imb_add_target_print_help("${IPSEC_MB_OPTIONS}")

=== examples/CMakeLists.txt ===
# cmake-format: off
# Copyright (c) 2023-2024, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# cmake-format: on

# Ensure building entire project
if(NOT FULL_PROJECT_BUILD)
  message(FATAL_ERROR "Please run CMake from project root directory")
endif()

# build imb-burst application
add_subdirectory(burst-app)

=== lib/CMakeLists.txt ===
# cmake-format: off
# Copyright (c) 2022-2024, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# cmake-format: on

# ##############################################################################
# Build IPSec_MB library
# ##############################################################################

# ensure building entire project
if(NOT FULL_PROJECT_BUILD)
  message(FATAL_ERROR "Please run CMake from project root directory")
endif()

# ##############################################################################
# setup NASM
# ##############################################################################
if(NOT CMAKE_ASM_NASM_COMPILER)
  set(CMAKE_ASM_NASM_COMPILER nasm)
endif()
enable_language(ASM_NASM)
if(NOT CMAKE_ASM_NASM_COMPILER_LOADED)
  message(FATAL_ERROR "Can't find assembler")
endif()

set(NASM_VERSION_REQUIRED "2.14")
set(NASM_VERSION_AVX_IFMA "2.16")
set(NASM_VERSION_SMX_NI "2.16.02")

execute_process(
  COMMAND ${CMAKE_ASM_NASM_COMPILER} -v
  OUTPUT_VARIABLE NASM_VERSION_OUTPUT
  OUTPUT_STRIP_TRAILING_WHITESPACE)
string(REGEX MATCH "NASM version ([0-9]*.[0-9]*.[0-9]*)" NASM_VERSION
             "${NASM_VERSION_OUTPUT}")
if(NASM_VERSION)
  if(NASM_VERSION_REQUIRED VERSION_GREATER ${CMAKE_MATCH_1})
    message(
      FATAL_ERROR "NASM version must be at least ${NASM_VERSION_REQUIRED}!")
  endif()
  message(STATUS "NASM version: ${CMAKE_MATCH_1}")
  if(NASM_VERSION_AVX_IFMA VERSION_GREATER ${CMAKE_MATCH_1})
    message(
      NOTICE
      "Minimum required NASM version for AVX-IFMA: ${NASM_VERSION_AVX_IFMA}. AVX-IFMA code not compiled - update NASM."
    )
  else()
    # AVX IFMA supported by NASM
    set(AVX_IFMA 1)
  endif()
  if(NASM_VERSION_SMX_NI VERSION_GREATER ${CMAKE_MATCH_1})
    message(
      NOTICE
      "Minimum required NASM version for SM3/SM4/SHA512-NI: ${NASM_VERSION_SMX_NI}. SM3/SM4/SHA512-NI code not compiled - update NASM."
    )
  else()
    # SM3/SM4/SHA512-NI supported by NASM
    set(SMX_NI 1)
  endif()
else()
  message(
    WARNING
      "Could not parse NASM version string: ${NASM_VERSION_OUTPUT}.\nPlease, be sure that ${CMAKE_ASM_NASM_COMPILER} version is >= ${NASM_VERSION_REQUIRED}"
  )
endif()

set(CAN_USE_ASSEMBLER 1)

# ##############################################################################
# set library directories
# ##############################################################################
set(DIR_CURRENT ${CMAKE_CURRENT_SOURCE_DIR}/)
set(DIR_INCLUDE ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(DIR_AVX_T1 ${CMAKE_CURRENT_SOURCE_DIR}/avx_t1)
set(DIR_AVX2_T1 ${CMAKE_CURRENT_SOURCE_DIR}/avx2_t1)
set(DIR_AVX2_T2 ${CMAKE_CURRENT_SOURCE_DIR}/avx2_t2)
set(DIR_AVX512_T1 ${CMAKE_CURRENT_SOURCE_DIR}/avx512_t1)
set(DIR_AVX512_T2 ${CMAKE_CURRENT_SOURCE_DIR}/avx512_t2)
set(DIR_SSE_T1 ${CMAKE_CURRENT_SOURCE_DIR}/sse_t1)
set(DIR_SSE_T2 ${CMAKE_CURRENT_SOURCE_DIR}/sse_t2)
set(DIR_SSE_T3 ${CMAKE_CURRENT_SOURCE_DIR}/sse_t3)
set(DIR_X86_64 ${CMAKE_CURRENT_SOURCE_DIR}/x86_64)
if(AVX_IFMA)
  set(DIR_AVX2_T3 ${CMAKE_CURRENT_SOURCE_DIR}/avx2_t3)
endif()
if(SMX_NI)
  set(DIR_AVX2_T4 ${CMAKE_CURRENT_SOURCE_DIR}/avx2_t4)
endif()
# ##############################################################################
# create list of all source directories
# ##############################################################################
set(DIR_SOURCES
    ${DIR_AVX_T1}
    ${DIR_AVX_T2}
    ${DIR_AVX2_T1}
    ${DIR_AVX2_T2}
    ${DIR_AVX2_T4}
    ${DIR_AVX512_T1}
    ${DIR_AVX512_T2}
    ${DIR_SSE_T1}
    ${DIR_SSE_T2}
    ${DIR_SSE_T3}
    ${DIR_X86_64})

if(AVX_IFMA)
  list(APPEND DIR_SOURCES ${DIR_AVX2_T3})
endif()

# ##############################################################################
# find C source files in all directories
# ##############################################################################
file(GLOB SRC_FILES_AVX_T1 "${DIR_AVX_T1}/*.c")
file(GLOB SRC_FILES_AVX_T2 "${DIR_AVX_T2}/*.c")
file(GLOB SRC_FILES_AVX2_T1 "${DIR_AVX2_T1}/*.c")
file(GLOB SRC_FILES_AVX2_T2 "${DIR_AVX2_T2}/*.c")
file(GLOB SRC_FILES_AVX2_T3 "${DIR_AVX2_T3}/*.c")
file(GLOB SRC_FILES_AVX2_T4 "${DIR_AVX2_T4}/*.c")
file(GLOB SRC_FILES_AVX512_T1 "${DIR_AVX512_T1}/*.c")
file(GLOB SRC_FILES_AVX512_T2 "${DIR_AVX512_T2}/*.c")
file(GLOB SRC_FILES_SSE_T1 "${DIR_SSE_T1}/*.c")
file(GLOB SRC_FILES_SSE_T2 "${DIR_SSE_T2}/*.c")
file(GLOB SRC_FILES_SSE_T3 "${DIR_SSE_T3}/*.c")
file(GLOB SRC_FILES_X86_64 "${DIR_X86_64}/*.c")

# create list of all C source files
set(SRC_FILES_C
    ${SRC_FILES_AVX_T1}
    ${SRC_FILES_AVX_T2}
    ${SRC_FILES_AVX2_T1}
    ${SRC_FILES_AVX2_T2}
    ${SRC_FILES_AVX512_T1}
    ${SRC_FILES_AVX512_T2}
    ${SRC_FILES_SSE_T1}
    ${SRC_FILES_SSE_T2}
    ${SRC_FILES_SSE_T3}
    ${SRC_FILES_X86_64}
    ${SRC_FILES_AVX2_T4})
if(AVX_IFMA)
  list(APPEND SRC_FILES_C ${SRC_FILES_AVX2_T3})
endif()
if(SMX_NI)
  list(APPEND SRC_FILES_C ${SRC_FILES_AVX2_T4})
endif()

list(SORT SRC_FILES_C)

# ##############################################################################
# generate list of assembly source files
# ##############################################################################
foreach(DIR ${DIR_SOURCES})
  file(GLOB_RECURSE TMP "${DIR}/*.asm")
  list(APPEND SRC_FILES_ASM ${TMP})
endforeach()

list(SORT SRC_FILES_ASM)

# ##############################################################################
# set C compiler options
# ##############################################################################
set(LIB_DEFINES)

# enable SAFE OPTIONS
if(SAFE_DATA)
  list(APPEND LIB_DEFINES SAFE_DATA)
  string(APPEND CMAKE_ASM_NASM_FLAGS " -DSAFE_DATA")
endif()
if(SAFE_PARAM)
  list(APPEND LIB_DEFINES SAFE_PARAM)
  string(APPEND CMAKE_ASM_NASM_FLAGS " -DSAFE_PARAM")
endif()
if(SAFE_LOOKUP)
  list(APPEND LIB_DEFINES SAFE_LOOKUP)
  string(APPEND CMAKE_ASM_NASM_FLAGS " -DSAFE_LOOKUP")
endif()

# enable AVX IFMA support
if(AVX_IFMA)
  list(APPEND LIB_DEFINES AVX_IFMA)
endif()
# enable SMX-NI support
if(SMX_NI)
  list(APPEND LIB_DEFINES SMX_NI)
endif()

# ##############################################################################
# add OS specific options
# ##############################################################################
if(WINDOWS)
  if(CMAKE_GENERATOR MATCHES "MinGW Makefiles")
    include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/windows-mingw.cmake)
  else()
    include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/windows.cmake)
  endif()
else()
  include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/unix.cmake)
endif()

# add user defined cflags
string(APPEND CMAKE_C_FLAGS " ${EXTRA_CFLAGS}")

# add library definitions to all C source files
foreach(FILE ${SRC_FILES_C})
  set_source_files_properties(${FILE} PROPERTIES COMPILE_DEFINITIONS
                                                 "${LIB_DEFINES}")
endforeach()

# add include directories
target_include_directories(${LIB} PRIVATE ${DIR_CURRENT} ${DIR_INCLUDE})

=== perf/CMakeLists.txt ===
# cmake-format: off
# Copyright (c) 2023-2024, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# cmake-format: on

# Ensure building entire project
if(NOT FULL_PROJECT_BUILD)
  message(FATAL_ERROR "Please run CMake from project root directory")
endif()

# ##############################################################################
# set app and library names
# ##############################################################################
set(PERF_APP imb-perf)
set(LIB_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../lib)

# ##############################################################################
# set source files
# ##############################################################################
set(PERF_APP_SRC_FILES ${CMAKE_CURRENT_SOURCE_DIR}/ipsec_perf.c
                       ${CMAKE_CURRENT_SOURCE_DIR}/msr.c)

set(PERF_APP_SRC_FILES_ASM ${CMAKE_CURRENT_SOURCE_DIR}/misc.asm)

# ##############################################################################
# add target
# ##############################################################################
add_executable(${PERF_APP} ${PERF_APP_SRC_FILES} ${PERF_APP_SRC_FILES_ASM})

# ##############################################################################
# setup NASM
# ##############################################################################
enable_language(ASM_NASM)
if(NOT CMAKE_ASM_NASM_COMPILER_LOADED)
  message(FATAL_ERROR "Can't find assembler")
endif()
set(CAN_USE_ASSEMBLER TRUE)

# ##############################################################################
# set C compiler and NASM options
# ##############################################################################
# add OS specific options
if(WINDOWS)
  if(CMAKE_GENERATOR MATCHES "MinGW Makefiles")
    include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/windows-mingw.cmake)
  else()
    include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/windows.cmake)
  endif()
else()
  include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/unix.cmake)
endif()

# ##############################################################################
# extra target properties
# ##############################################################################
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${LIB_DIR})
link_directories(${LIB_DIR})

target_link_libraries(${PERF_APP} PRIVATE ${IPSEC_MB_LIB})
target_compile_definitions(${PERF_APP} PRIVATE ${APP_DEFINES})

# ##############################################################################
# include tests
# ##############################################################################

include(perf_tests.cmake)

=== test/CMakeLists.txt ===
# cmake-format: off
# Copyright (c) 2022-2024, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# cmake-format: on

# Ensure building entire project
if(NOT FULL_PROJECT_BUILD)
  message(FATAL_ERROR "Please run CMake from project root directory")
endif()

# build imb-kat application
add_subdirectory(kat-app)

# build imb-xvalid application
add_subdirectory(xvalid-app)

# build imb-wycheproof application
add_subdirectory(wycheproof-app)

# build imb-mp application
add_subdirectory(mp-app)

if(NOT WINDOWS)
  # build imb-acvp if libacvp available
  if(NOT ACVP_LOC)
    set(ACVP_LOC "/usr/local/acvp")
  endif()
  set(ACVP_INCLUDE_DIR "${ACVP_LOC}/include")

  # find libacvp
  find_library(
    ACVP_LIB libacvp.a libacvp
    PATHS ${ACVP_LOC}
    PATH_SUFFIXES lib)

  # add imb-acvp app if found
  if(ACVP_LIB)
    message(STATUS "ACVP_LIB...                ${ACVP_LIB}")
    add_subdirectory(acvp-app)
  endif()

  # add fuzz apps if using clang
  if(CMAKE_C_COMPILER_ID MATCHES "Clang")
    add_subdirectory(fuzz-app)
  endif()
endif()

=== test/acvp-app/CMakeLists.txt ===
# cmake-format: off
# Copyright (c) 2023-2024, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice, this
#   list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
# * Neither the name of Intel Corporation nor the names of its contributors may
#   be used to endorse or promote products derived from this software without
#   specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# cmake-format: on

# Ensure building entire project
if(NOT FULL_PROJECT_BUILD)
  message(FATAL_ERROR "Please run CMake from project root directory")
endif()

# ##############################################################################
# set app and library names
# ##############################################################################
set(ACVP_APP imb-acvp)
set(LIB_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../lib)
set(TEST_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../include)

# ##############################################################################
# set imb-acvp source files
# ##############################################################################
set(ACVP_APP_SRC_FILES_C ${CMAKE_CURRENT_SOURCE_DIR}/acvp_app_main.c
                         ${CMAKE_CURRENT_SOURCE_DIR}/../common/utils.c)

# ##############################################################################
# set toolchain options
# ##############################################################################
include(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/unix.cmake)

include_directories(${LIB_DIR} ${TEST_INCLUDE_DIR} ${ACVP_INCLUDE_DIR})
link_directories(${LIB_DIR})

# ##############################################################################
# add target
# ##############################################################################
add_executable(${ACVP_APP} ${ACVP_APP_SRC_FILES_C})
target_link_libraries(${ACVP_APP} PRIVATE ${IPSEC_MB_LIB} ${ACVP_LIB})
target_compile_definitions(${ACVP_APP} PRIVATE ${APP_DEFINES})

=== test/fuzz-app/CMakeLists.txt ===
# cmake-format: off
# Copyright (c) 2023-2024, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice, this
#   list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
# * Neither the name of Intel Corporation nor the names of its contributors may
#   be used to endorse or promote products derived from this software without
#   specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# cmake-format: on

# Ensure building entire project
if(NOT FULL_PROJECT_BUILD)
  message(FATAL_ERROR "Please run CMake from project root directory")
endif()

# ##############################################################################
# set app and library names
# ##############################################################################
set(FUZZ_APP imb-fuzz-api)
set(DIRECT_FUZZ_APP imb-fuzz-direct-api)
set(LIB_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../lib)
set(TEST_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../include)

# ##############################################################################
# set source files
# ##############################################################################
set(FUZZ_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/job_api_fuzz_test.c)
set(DIRECT_FUZZ_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/direct_api_fuzz_test.c)

# ##############################################################################
# set toolchain options
# ##############################################################################
include(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/unix.cmake)
string(APPEND CMAKE_C_FLAGS " -g -fsanitize=fuzzer,address,leak")

include_directories(${LIB_DIR} ${TEST_INCLUDE_DIR})

# ##############################################################################
# add targets
# ##############################################################################
add_executable(${FUZZ_APP} ${FUZZ_SOURCES})
target_link_libraries(${FUZZ_APP} PRIVATE ${IPSEC_MB_LIB})
target_compile_definitions(${FUZZ_APP} PRIVATE ${APP_DEFINES})

add_executable(${DIRECT_FUZZ_APP} ${DIRECT_FUZZ_SOURCES})
target_link_libraries(${DIRECT_FUZZ_APP} PRIVATE ${IPSEC_MB_LIB})
target_compile_definitions(${DIRECT_FUZZ_APP} PRIVATE ${APP_DEFINES})

=== test/mp-app/CMakeLists.txt ===
# cmake-format: off
# Copyright (c) 2024, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# cmake-format: on

# Ensure building entire project
if(NOT FULL_PROJECT_BUILD)
  message(FATAL_ERROR "Please run CMake from project root directory")
endif()

# ##############################################################################
# set app and library names
# ##############################################################################
set(MP_APP_PRI imb-mp-primary)
set(MP_APP_SEC imb-mp-secondary)
set(LIB_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../lib)
set(TEST_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../include)

# ##############################################################################
# set imb-mp-primary source files
# ##############################################################################
set(MP_APP_PRI_SRC_FILES_C
    ${CMAKE_CURRENT_SOURCE_DIR}/imb-mp-primary.c
    ${CMAKE_CURRENT_SOURCE_DIR}/mp_shared_mem.c
    ${CMAKE_CURRENT_SOURCE_DIR}/mp_imb.c ${CMAKE_CURRENT_SOURCE_DIR}/mp_alloc.c)

# ##############################################################################
# set imb-mp-secondary source files
# ##############################################################################
set(MP_APP_SEC_SRC_FILES_C
    ${CMAKE_CURRENT_SOURCE_DIR}/imb-mp-secondary.c
    ${CMAKE_CURRENT_SOURCE_DIR}/mp_shared_mem.c
    ${CMAKE_CURRENT_SOURCE_DIR}/mp_imb.c ${CMAKE_CURRENT_SOURCE_DIR}/mp_alloc.c)

# ##############################################################################
# set C compiler and NASM options
# ##############################################################################
# add OS specific options
if(WINDOWS)
  if(CMAKE_GENERATOR MATCHES "MinGW Makefiles")
    include(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/windows-mingw.cmake)
  else()
    include(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/windows.cmake)
  endif()
else()
  include(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/unix.cmake)
endif()

# ##############################################################################
# add targets
# ##############################################################################
include_directories(${LIB_DIR} ${TEST_INCLUDE_DIR})
link_directories(${LIB_DIR})

add_executable(${MP_APP_PRI} ${MP_APP_PRI_SRC_FILES_C})
if(LINUX)
  target_link_libraries(${MP_APP_PRI} PRIVATE ${IPSEC_MB_LIB} rt)
else()
  target_link_libraries(${MP_APP_PRI} PRIVATE ${IPSEC_MB_LIB})
endif()
target_compile_definitions(${MP_APP_PRI} PRIVATE ${APP_DEFINES})

add_executable(${MP_APP_SEC} ${MP_APP_SEC_SRC_FILES_C})
if(LINUX)
  target_link_libraries(${MP_APP_SEC} PRIVATE ${IPSEC_MB_LIB} rt)
else()
  target_link_libraries(${MP_APP_SEC} PRIVATE ${IPSEC_MB_LIB})
endif()
target_compile_definitions(${MP_APP_SEC} PRIVATE ${APP_DEFINES})

# ##############################################################################
# add tests
# ##############################################################################

# set working directory for tests
if(IMB_BIN_DIR)
  set(APP_BIN_DIR "${IMB_BIN_DIR}")
else()
  set(APP_BIN_DIR "${CMAKE_CURRENT_BINARY_DIR}")
endif()

# append config type for multi-config generators
get_property(multi_config_gen GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(multi_config_gen)
  string(APPEND APP_BIN_DIR "/$<IF:$<CONFIG:Debug>,Debug,Release>")
endif()

add_test(
  NAME MULTIPROCESS::DEFAULT
  COMMAND ${MP_APP_PRI} ${APP_BIN_DIR}/${MP_APP_SEC}
  WORKING_DIRECTORY ${APP_BIN_DIR})

=== test/wycheproof-app/CMakeLists.txt ===
# cmake-format: off
# Copyright (c) 2023-2024, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# cmake-format: on

# Ensure building entire project
if(NOT FULL_PROJECT_BUILD)
  message(FATAL_ERROR "Please run CMake from project root directory")
endif()

# ##############################################################################
# set app and library names
# ##############################################################################
set(WYCHEPROOF_APP imb-wycheproof)
set(LIB_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../lib)
set(TEST_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../include)

# ##############################################################################
# set imb-wycheproof source files
# ##############################################################################
set(WYCHEPROOF_APP_SRC_FILES_C
    ${CMAKE_CURRENT_SOURCE_DIR}/aes_gcm_test.json.c
    ${CMAKE_CURRENT_SOURCE_DIR}/aes_ccm_test.json.c
    ${CMAKE_CURRENT_SOURCE_DIR}/chacha20_poly1305_test.json.c
    ${CMAKE_CURRENT_SOURCE_DIR}/aes_cmac_test.json.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gmac_test.json.c
    ${CMAKE_CURRENT_SOURCE_DIR}/gmac_test.json.c
    ${CMAKE_CURRENT_SOURCE_DIR}/hmac_sha1_test.json.c
    ${CMAKE_CURRENT_SOURCE_DIR}/hmac_sha224_test.json.c
    ${CMAKE_CURRENT_SOURCE_DIR}/hmac_sha256_test.json.c
    ${CMAKE_CURRENT_SOURCE_DIR}/hmac_sha384_test.json.c
    ${CMAKE_CURRENT_SOURCE_DIR}/hmac_sha512_test.json.c
    ${CMAKE_CURRENT_SOURCE_DIR}/wycheproof.c)

# ##############################################################################
# set C compiler and NASM options
# ##############################################################################
# add OS specific options
if(WINDOWS)
  if(CMAKE_GENERATOR MATCHES "MinGW Makefiles")
    include(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/windows-mingw.cmake)
  else()
    include(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/windows.cmake)
  endif()
else()
  include(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/unix.cmake)
endif()

# ##############################################################################
# add targets
# ##############################################################################
include_directories(${LIB_DIR} ${TEST_INCLUDE_DIR})
link_directories(${LIB_DIR})

add_executable(${WYCHEPROOF_APP} ${WYCHEPROOF_APP_SRC_FILES_C})
target_link_libraries(${WYCHEPROOF_APP} PRIVATE ${IPSEC_MB_LIB})
target_compile_definitions(${WYCHEPROOF_APP} PRIVATE ${APP_DEFINES})

# ##############################################################################
# add tests
# ##############################################################################

# set working directory for tests
if(IMB_BIN_DIR)
  set(APP_BIN_DIR "${IMB_BIN_DIR}")
else()
  set(APP_BIN_DIR "${CMAKE_CURRENT_BINARY_DIR}")
endif()

# append config type for multi-config generators
get_property(multi_config_gen GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(multi_config_gen)
  string(APPEND APP_BIN_DIR "/$<IF:$<CONFIG:Debug>,Debug,Release>")
endif()

add_test(
  NAME WYCHEPROOF::DEFAULT
  COMMAND ${WYCHEPROOF_APP}
  WORKING_DIRECTORY ${APP_BIN_DIR})

add_test(
  NAME WYCHEPROOF::SHANI_OFF
  COMMAND ${WYCHEPROOF_APP} --shani-off
  WORKING_DIRECTORY ${APP_BIN_DIR})

add_test(
  NAME WYCHEPROOF::GFNI_OFF
  COMMAND ${WYCHEPROOF_APP} --gfni-off
  WORKING_DIRECTORY ${APP_BIN_DIR})

=== test/xvalid-app/CMakeLists.txt ===
# cmake-format: off
# Copyright (c) 2023-2024, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# cmake-format: on

# Ensure building entire project
if(NOT FULL_PROJECT_BUILD)
  message(FATAL_ERROR "Please run CMake from project root directory")
endif()

# ##############################################################################
# set app and library names
# ##############################################################################
set(XVALID_APP imb-xvalid)
set(LIB_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../lib)
set(TEST_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../include)

# ##############################################################################
# set imb-xvalid source files
# ##############################################################################
set(XVALID_APP_SRC_FILES_C ${CMAKE_CURRENT_SOURCE_DIR}/ipsec_xvalid.c
                           ${CMAKE_CURRENT_SOURCE_DIR}/../common/utils.c)
set(XVALID_APP_SRC_FILES_ASM ${CMAKE_CURRENT_SOURCE_DIR}/misc.asm)

# ##############################################################################
# setup NASM
# ##############################################################################
enable_language(ASM_NASM)
if(NOT CMAKE_ASM_NASM_COMPILER_LOADED)
  message(FATAL_ERROR "Can't find assembler")
endif()
set(CAN_USE_ASSEMBLER TRUE)

# ##############################################################################
# set C compiler and NASM options
# ##############################################################################
# add OS specific options
if(WINDOWS)
  if(CMAKE_GENERATOR MATCHES "MinGW Makefiles")
    include(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/windows-mingw.cmake)
  else()
    include(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/windows.cmake)
  endif()
else()
  include(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/unix.cmake)
endif()

# ##############################################################################
# add targets
# ##############################################################################
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${LIB_DIR} ${TEST_INCLUDE_DIR})
link_directories(${LIB_DIR})

add_executable(${XVALID_APP} ${XVALID_APP_SRC_FILES_C}
                             ${XVALID_APP_SRC_FILES_ASM})
target_link_libraries(${XVALID_APP} PRIVATE ${IPSEC_MB_LIB})
target_compile_definitions(${XVALID_APP} PRIVATE ${APP_DEFINES})

# ##############################################################################
# add tests
# ##############################################################################

include(xvalid_tests.cmake)

=== debian/changelog ===
intel-ipsec-mb (2.0.1-2) unstable; urgency=medium

  * Orphan upload
  * Update Maintainer field to Debian QA Group <packages@qa.debian.org>
    so package can be orphaned

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 15 Sep 2025 14:38:12 +0100

intel-ipsec-mb (2.0.1-1) unstable; urgency=medium

  * Sync to latest 2.0.1 release
  * Remove external doc hypertext links to clean up privacy-breach-generic
    warnings

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 14 Jul 2025 11:57:23 +0100

=== debian/control ===
Source: intel-ipsec-mb
Rules-Requires-Root: no
Section: utils
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 13),
               debhelper-compat (=13),
               cmake,
               nasm
Standards-Version: 4.7.2
Homepage: https://github.com/intel/intel-ipsec-mb

Package: libipsec-mb2
Section: libs
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Intel(R) Multi-Buffer Crypto for IPSec library
 Libipsec-mb is highly-optimized software implementations of
 the core cryptographic processing for IPsec, which provides
 industry-leading performance on a range of Intel(R) Processors.

Package: libipsec-mb-dev
Section: libdevel
Architecture: linux-amd64
Depends: ${misc:Depends}, libipsec-mb2 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: Development files for Intel(R) Multi-Buffer Crypto for IPSec library
 Libipsec-mb is highly-optimized software implementations of
 the core cryptographic processing for IPsec, which provides
 industry-leading performance on a range of Intel(R) Processors.
 This package contains the development libraries and headers.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

DESTDIR=$$(pwd)/debian/tmp
LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
HDRDIR=/usr/include
MANDIR=/usr/share/man/man7
DOCDIR=/usr/share/doc

VERSION_MAJOR=$(shell grep -e "IMB_VERSION_STR" lib/intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f1)
VERSION_MINOR=$(shell grep -e "IMB_VERSION_STR" lib/intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f2)
VERSION_PATCH=$(shell grep -e "IMB_VERSION_STR" lib/intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f3)

MAN1 = libipsec-mb.7
MAN2 = libipsec-mb-dev.7

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_configure:

override_dh_auto_build:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=OFF
	find . -type f -name "*.o" -print -exec rm {} \;
	$(shell dpkg-buildflags --export=sh); dh_auto_build --
	find $$(pwd) -name "libIPSec_MB.*" -exec ls -al {} \;

	#dh_auto_install

	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON
	find . -type f -name "*.o" -print -exec rm {} \;
	$(shell dpkg-buildflags --export=sh); dh_auto_build --
	find $$(pwd) -name "libIPSec_MB.*" -exec ls -al {} \;

	find $$(pwd) -name "libIPSec_MB.so*" -exec ls -al {} \;
	find $$(pwd) -name "libIPSec_MB.a" -exec ls -al {} \;
	#dh_auto_install

override_dh_auto_install:
	#find $$(pwd) -name "libIPSec_MB.so*" -exec ls -al {} \;
	#find $$(pwd) -name "libIPSec_MB.a" -exec ls -al {} \;
	dh_auto_configure -- -DBUILD_SHARED_LIBS=OFF
	dh_auto_install
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON
	dh_auto_install

#
# Disable elf debug optimization step
#
override_dh_dwz:

%:
	dh $@
	dh_makeshlibs
	dh_shlibdeps

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?V?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
             https://github.com/intel/intel-ipsec-mb/tags \
             (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## intel-ipsec-mb 2.0.1+dfsg

=== debian/changelog ===
intel-ipsec-mb (2.0.1+dfsg-1) sid; urgency=medium

  * Merging upstream version 2.0.1+dfsg.
  * Wrap and sorting debian files.
  * Removing rules-requires-root field, not needed anymore.
  * Re-adding source priority field for reprepro compatibility (#1110733).
  * Updating vcs fields.
  * Removing unused pre-depends fields.
  * Harmonizing watch file.
  * Tidy copyright file.
  * Tidy debhelper install files.
  * Tidy debhelper docs files.
  * Harmonizing build-depends.
  * Tidy rules file.
  * Harmonizing architecture fields.
  * Harmonizing package descriptions.
  * Reworking rules to do the same but much simpler.
  * Removing remove-makefile.patch, not needed anymore when using build
    directories.
  * Removing docs-index.patch, not needed anymore as docs aren't included
    anymore.
  * Removing lintian-overrides, not needed anymore.
  * Adding upstream metadata.
  * Updating years in copyright for 2026.

 -- Daniel Baumann <daniel@debian.org>  Sat, 03 Jan 2026 03:34:43 +0100

intel-ipsec-mb (2.0.1-4) sid; urgency=medium

  * New maintainer (Closes: #1111169).

 -- Daniel Baumann <daniel@debian.org>  Fri, 02 Jan 2026 18:40:54 +0100

intel-ipsec-mb (2.0.1-3) unstable; urgency=medium

  * QA upload.
  * Maintain in Debian team on Salsa
  * d/watch: version=5
  * No explicit Build-Depends: debhelper
  * Standards-Version: 4.7.3 (routine-update)
  * Remove Priority field to comply with Debian Policy 4.7.3 (routine-
    update)
  * Update lintian override info format in d/source/lintian-overrides
  * d/copyright: Review

 -- Andreas Tille <tille@debian.org>  Tue, 23 Dec 2025 21:48:12 +0100

=== debian/control ===
Source: intel-ipsec-mb
Section: utils
Priority: optional
Maintainer: Daniel Baumann <daniel@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 nasm,
Standards-Version: 4.7.3
Homepage: https://github.com/intel/intel-ipsec-mb
Vcs-Browser: https://forgejo.debian.net/intel/intel-ipsec-mb
Vcs-Git: https://forgejo.debian.net/intel/intel-ipsec-mb

Package: libipsec-mb2
Section: libs
Architecture: amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Intel Multi-Buffer Crypto for IPsec (library)
 The Multi-Buffer Crypto for IPsec library provides software crypto acceleration
 primarily targeting packet processing applications, e.g. DPDK and QAT.
 .
 This package contains the shared library.

Package: libipsec-mb-dev
Section: libdevel
Architecture: amd64
Depends:
 libipsec-mb2 (= ${binary:Version}),
 ${misc:Depends},
Description: Intel Multi-Buffer Crypto for IPsec (development)
 The Multi-Buffer Crypto for IPsec library provides software crypto acceleration
 primarily targeting packet processing applications, e.g. DPDK and QAT.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh ${@}

execute_after_dh_auto_clean:
	rm -rf build-static
	rm -rf build-shared

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-static -- -DBUILD_SHARED_LIBS=OFF
	dh_auto_configure --builddirectory=build-shared -- -DBUILD_SHARED_LIBS=ON

override_dh_auto_build:
	dh_auto_build --builddirectory=build-static
	dh_auto_build --builddirectory=build-shared

override_dh_auto_test:
	dh_auto_test --builddirectory=build-static
	dh_auto_test --builddirectory=build-shared

override_dh_auto_install:
	dh_auto_install --builddirectory=build-static
	dh_auto_install --builddirectory=build-shared

=== debian/watch ===
Version: 5

Template: Github
Owner: intel
Project: @PACKAGE@
Dversion-Mangle: auto
